# -*- coding: utf-8 -*-

import dialog

class MenuItem(object):
    """
    Элемент меню
    """
    def __init__(self, name, callback):
        self.name = name
        self.callback = callback

class Menu(object):
    """
    Универсальное меню
    
    TODO Сделать поддержку древовидного меню.
    """
    def __init__(self, d, items, title='Выберите действие', width=0, height=0):
        self.d = d
        self.items = items
        self.title = title
        self.width = width
        self.height = height
        if self.height == 0:
            self.height = 7 + len(items)

    def getChoices(self):
        result = []
        for i in range(len(self.items)):
            result.append((str(i + 1), self.items[i].name))
        return result

    def run(self):
        run = True
        current = '1'
        while run:
            code, tag = self.d.menu(self.title, width = self.width, height = self.height,
                    choices = self.getChoices(), default_item = current)
            if code is self.d.DIALOG_OK:
                current = tag
                itemCode = int(tag) - 1
                self.items[itemCode].callback()
            else:
                run = False